//go:build !ignore_autogenerated

/*
Copyright 2025 Orange.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by controller-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
)

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *CommonSpec) DeepCopyInto(out *CommonSpec) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new CommonSpec.
func (in *CommonSpec) DeepCopy() *CommonSpec {
	if in == nil {
		return nil
	}
	out := new(CommonSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *CommonStatus) DeepCopyInto(out *CommonStatus) {
	*out = *in
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make([]v1.Condition, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new CommonStatus.
func (in *CommonStatus) DeepCopy() *CommonStatus {
	if in == nil {
		return nil
	}
	out := new(CommonStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *FixedIP) DeepCopyInto(out *FixedIP) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new FixedIP.
func (in *FixedIP) DeepCopy() *FixedIP {
	if in == nil {
		return nil
	}
	out := new(FixedIP)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackCloud) DeepCopyInto(out *OpenStackCloud) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackCloud.
func (in *OpenStackCloud) DeepCopy() *OpenStackCloud {
	if in == nil {
		return nil
	}
	out := new(OpenStackCloud)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackCloud) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackCloudCredentials) DeepCopyInto(out *OpenStackCloudCredentials) {
	*out = *in
	out.SecretRef = in.SecretRef
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackCloudCredentials.
func (in *OpenStackCloudCredentials) DeepCopy() *OpenStackCloudCredentials {
	if in == nil {
		return nil
	}
	out := new(OpenStackCloudCredentials)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackCloudCredentialsSecretRef) DeepCopyInto(out *OpenStackCloudCredentialsSecretRef) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackCloudCredentialsSecretRef.
func (in *OpenStackCloudCredentialsSecretRef) DeepCopy() *OpenStackCloudCredentialsSecretRef {
	if in == nil {
		return nil
	}
	out := new(OpenStackCloudCredentialsSecretRef)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackCloudList) DeepCopyInto(out *OpenStackCloudList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackCloud, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackCloudList.
func (in *OpenStackCloudList) DeepCopy() *OpenStackCloudList {
	if in == nil {
		return nil
	}
	out := new(OpenStackCloudList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackCloudList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackCloudSpec) DeepCopyInto(out *OpenStackCloudSpec) {
	*out = *in
	out.Credentials = in.Credentials
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackCloudSpec.
func (in *OpenStackCloudSpec) DeepCopy() *OpenStackCloudSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackCloudSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackCloudStatus) DeepCopyInto(out *OpenStackCloudStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackCloudStatus.
func (in *OpenStackCloudStatus) DeepCopy() *OpenStackCloudStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackCloudStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFlavor) DeepCopyInto(out *OpenStackFlavor) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFlavor.
func (in *OpenStackFlavor) DeepCopy() *OpenStackFlavor {
	if in == nil {
		return nil
	}
	out := new(OpenStackFlavor)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackFlavor) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFlavorList) DeepCopyInto(out *OpenStackFlavorList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackFlavor, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFlavorList.
func (in *OpenStackFlavorList) DeepCopy() *OpenStackFlavorList {
	if in == nil {
		return nil
	}
	out := new(OpenStackFlavorList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackFlavorList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFlavorResourceSpec) DeepCopyInto(out *OpenStackFlavorResourceSpec) {
	*out = *in
	if in.IsPublic != nil {
		in, out := &in.IsPublic, &out.IsPublic
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFlavorResourceSpec.
func (in *OpenStackFlavorResourceSpec) DeepCopy() *OpenStackFlavorResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackFlavorResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFlavorResourceStatus) DeepCopyInto(out *OpenStackFlavorResourceStatus) {
	*out = *in
	if in.ExtraSpecs != nil {
		in, out := &in.ExtraSpecs, &out.ExtraSpecs
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFlavorResourceStatus.
func (in *OpenStackFlavorResourceStatus) DeepCopy() *OpenStackFlavorResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackFlavorResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFlavorSpec) DeepCopyInto(out *OpenStackFlavorSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackFlavorResourceSpec)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFlavorSpec.
func (in *OpenStackFlavorSpec) DeepCopy() *OpenStackFlavorSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackFlavorSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFlavorStatus) DeepCopyInto(out *OpenStackFlavorStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	in.Resource.DeepCopyInto(&out.Resource)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFlavorStatus.
func (in *OpenStackFlavorStatus) DeepCopy() *OpenStackFlavorStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackFlavorStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFloatingIP) DeepCopyInto(out *OpenStackFloatingIP) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFloatingIP.
func (in *OpenStackFloatingIP) DeepCopy() *OpenStackFloatingIP {
	if in == nil {
		return nil
	}
	out := new(OpenStackFloatingIP)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackFloatingIP) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFloatingIPList) DeepCopyInto(out *OpenStackFloatingIPList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackFloatingIP, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFloatingIPList.
func (in *OpenStackFloatingIPList) DeepCopy() *OpenStackFloatingIPList {
	if in == nil {
		return nil
	}
	out := new(OpenStackFloatingIPList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackFloatingIPList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFloatingIPResourceSpec) DeepCopyInto(out *OpenStackFloatingIPResourceSpec) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFloatingIPResourceSpec.
func (in *OpenStackFloatingIPResourceSpec) DeepCopy() *OpenStackFloatingIPResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackFloatingIPResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFloatingIPResourceStatus) DeepCopyInto(out *OpenStackFloatingIPResourceStatus) {
	*out = *in
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFloatingIPResourceStatus.
func (in *OpenStackFloatingIPResourceStatus) DeepCopy() *OpenStackFloatingIPResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackFloatingIPResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFloatingIPSpec) DeepCopyInto(out *OpenStackFloatingIPSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackFloatingIPResourceSpec)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFloatingIPSpec.
func (in *OpenStackFloatingIPSpec) DeepCopy() *OpenStackFloatingIPSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackFloatingIPSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackFloatingIPStatus) DeepCopyInto(out *OpenStackFloatingIPStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	in.Resource.DeepCopyInto(&out.Resource)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackFloatingIPStatus.
func (in *OpenStackFloatingIPStatus) DeepCopy() *OpenStackFloatingIPStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackFloatingIPStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackImage) DeepCopyInto(out *OpenStackImage) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackImage.
func (in *OpenStackImage) DeepCopy() *OpenStackImage {
	if in == nil {
		return nil
	}
	out := new(OpenStackImage)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackImage) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackImageList) DeepCopyInto(out *OpenStackImageList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackImage, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackImageList.
func (in *OpenStackImageList) DeepCopy() *OpenStackImageList {
	if in == nil {
		return nil
	}
	out := new(OpenStackImageList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackImageList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackImageResourceSpec) DeepCopyInto(out *OpenStackImageResourceSpec) {
	*out = *in
	if in.Protected != nil {
		in, out := &in.Protected, &out.Protected
		*out = new(bool)
		**out = **in
	}
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Visibility != nil {
		in, out := &in.Visibility, &out.Visibility
		*out = new(string)
		**out = **in
	}
	if in.WebDownload != nil {
		in, out := &in.WebDownload, &out.WebDownload
		*out = new(OpenStackImageResourceWebDownload)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackImageResourceSpec.
func (in *OpenStackImageResourceSpec) DeepCopy() *OpenStackImageResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackImageResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackImageResourceStatus) DeepCopyInto(out *OpenStackImageResourceStatus) {
	*out = *in
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Metadata != nil {
		in, out := &in.Metadata, &out.Metadata
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.Properties != nil {
		in, out := &in.Properties, &out.Properties
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.ImportMethods != nil {
		in, out := &in.ImportMethods, &out.ImportMethods
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.StoreIDs != nil {
		in, out := &in.StoreIDs, &out.StoreIDs
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackImageResourceStatus.
func (in *OpenStackImageResourceStatus) DeepCopy() *OpenStackImageResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackImageResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackImageResourceWebDownload) DeepCopyInto(out *OpenStackImageResourceWebDownload) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackImageResourceWebDownload.
func (in *OpenStackImageResourceWebDownload) DeepCopy() *OpenStackImageResourceWebDownload {
	if in == nil {
		return nil
	}
	out := new(OpenStackImageResourceWebDownload)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackImageSpec) DeepCopyInto(out *OpenStackImageSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackImageResourceSpec)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackImageSpec.
func (in *OpenStackImageSpec) DeepCopy() *OpenStackImageSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackImageSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackImageStatus) DeepCopyInto(out *OpenStackImageStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	in.Resource.DeepCopyInto(&out.Resource)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackImageStatus.
func (in *OpenStackImageStatus) DeepCopy() *OpenStackImageStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackImageStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackKeypair) DeepCopyInto(out *OpenStackKeypair) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackKeypair.
func (in *OpenStackKeypair) DeepCopy() *OpenStackKeypair {
	if in == nil {
		return nil
	}
	out := new(OpenStackKeypair)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackKeypair) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackKeypairList) DeepCopyInto(out *OpenStackKeypairList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackKeypair, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackKeypairList.
func (in *OpenStackKeypairList) DeepCopy() *OpenStackKeypairList {
	if in == nil {
		return nil
	}
	out := new(OpenStackKeypairList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackKeypairList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackKeypairResourceSpec) DeepCopyInto(out *OpenStackKeypairResourceSpec) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackKeypairResourceSpec.
func (in *OpenStackKeypairResourceSpec) DeepCopy() *OpenStackKeypairResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackKeypairResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackKeypairResourceStatus) DeepCopyInto(out *OpenStackKeypairResourceStatus) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackKeypairResourceStatus.
func (in *OpenStackKeypairResourceStatus) DeepCopy() *OpenStackKeypairResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackKeypairResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackKeypairSpec) DeepCopyInto(out *OpenStackKeypairSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackKeypairResourceSpec)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackKeypairSpec.
func (in *OpenStackKeypairSpec) DeepCopy() *OpenStackKeypairSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackKeypairSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackKeypairStatus) DeepCopyInto(out *OpenStackKeypairStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	out.Resource = in.Resource
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackKeypairStatus.
func (in *OpenStackKeypairStatus) DeepCopy() *OpenStackKeypairStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackKeypairStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackNetwork) DeepCopyInto(out *OpenStackNetwork) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackNetwork.
func (in *OpenStackNetwork) DeepCopy() *OpenStackNetwork {
	if in == nil {
		return nil
	}
	out := new(OpenStackNetwork)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackNetwork) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackNetworkList) DeepCopyInto(out *OpenStackNetworkList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackNetwork, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackNetworkList.
func (in *OpenStackNetworkList) DeepCopy() *OpenStackNetworkList {
	if in == nil {
		return nil
	}
	out := new(OpenStackNetworkList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackNetworkList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackNetworkResourceSpec) DeepCopyInto(out *OpenStackNetworkResourceSpec) {
	*out = *in
	if in.AdminStateUp != nil {
		in, out := &in.AdminStateUp, &out.AdminStateUp
		*out = new(bool)
		**out = **in
	}
	if in.PortSecurityEnabled != nil {
		in, out := &in.PortSecurityEnabled, &out.PortSecurityEnabled
		*out = new(bool)
		**out = **in
	}
	if in.External != nil {
		in, out := &in.External, &out.External
		*out = new(bool)
		**out = **in
	}
	out.OpenStackNetworkSegment = in.OpenStackNetworkSegment
	if in.Segments != nil {
		in, out := &in.Segments, &out.Segments
		*out = make([]OpenStackNetworkSegment, len(*in))
		copy(*out, *in)
	}
	if in.Shared != nil {
		in, out := &in.Shared, &out.Shared
		*out = new(bool)
		**out = **in
	}
	if in.VLANTransparent != nil {
		in, out := &in.VLANTransparent, &out.VLANTransparent
		*out = new(bool)
		**out = **in
	}
	if in.IsDefault != nil {
		in, out := &in.IsDefault, &out.IsDefault
		*out = new(bool)
		**out = **in
	}
	if in.AvailabilityZoneHints != nil {
		in, out := &in.AvailabilityZoneHints, &out.AvailabilityZoneHints
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackNetworkResourceSpec.
func (in *OpenStackNetworkResourceSpec) DeepCopy() *OpenStackNetworkResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackNetworkResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackNetworkResourceStatus) DeepCopyInto(out *OpenStackNetworkResourceStatus) {
	*out = *in
	if in.AvailabilityZoneHints != nil {
		in, out := &in.AvailabilityZoneHints, &out.AvailabilityZoneHints
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.AvailabilityZones != nil {
		in, out := &in.AvailabilityZones, &out.AvailabilityZones
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.L2Adjacency != nil {
		in, out := &in.L2Adjacency, &out.L2Adjacency
		*out = new(bool)
		**out = **in
	}
	if in.PortSecurityEnabled != nil {
		in, out := &in.PortSecurityEnabled, &out.PortSecurityEnabled
		*out = new(bool)
		**out = **in
	}
	out.OpenStackNetworkSegment = in.OpenStackNetworkSegment
	if in.Segments != nil {
		in, out := &in.Segments, &out.Segments
		*out = make([]OpenStackNetworkSegment, len(*in))
		copy(*out, *in)
	}
	if in.Subnets != nil {
		in, out := &in.Subnets, &out.Subnets
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.IsDefault != nil {
		in, out := &in.IsDefault, &out.IsDefault
		*out = new(bool)
		**out = **in
	}
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackNetworkResourceStatus.
func (in *OpenStackNetworkResourceStatus) DeepCopy() *OpenStackNetworkResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackNetworkResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackNetworkSegment) DeepCopyInto(out *OpenStackNetworkSegment) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackNetworkSegment.
func (in *OpenStackNetworkSegment) DeepCopy() *OpenStackNetworkSegment {
	if in == nil {
		return nil
	}
	out := new(OpenStackNetworkSegment)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackNetworkSpec) DeepCopyInto(out *OpenStackNetworkSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackNetworkResourceSpec)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackNetworkSpec.
func (in *OpenStackNetworkSpec) DeepCopy() *OpenStackNetworkSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackNetworkSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackNetworkStatus) DeepCopyInto(out *OpenStackNetworkStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	in.Resource.DeepCopyInto(&out.Resource)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackNetworkStatus.
func (in *OpenStackNetworkStatus) DeepCopy() *OpenStackNetworkStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackNetworkStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackPort) DeepCopyInto(out *OpenStackPort) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackPort.
func (in *OpenStackPort) DeepCopy() *OpenStackPort {
	if in == nil {
		return nil
	}
	out := new(OpenStackPort)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackPort) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackPortAllowedAddressPair) DeepCopyInto(out *OpenStackPortAllowedAddressPair) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackPortAllowedAddressPair.
func (in *OpenStackPortAllowedAddressPair) DeepCopy() *OpenStackPortAllowedAddressPair {
	if in == nil {
		return nil
	}
	out := new(OpenStackPortAllowedAddressPair)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackPortDHCPOption) DeepCopyInto(out *OpenStackPortDHCPOption) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackPortDHCPOption.
func (in *OpenStackPortDHCPOption) DeepCopy() *OpenStackPortDHCPOption {
	if in == nil {
		return nil
	}
	out := new(OpenStackPortDHCPOption)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackPortList) DeepCopyInto(out *OpenStackPortList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackPort, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackPortList.
func (in *OpenStackPortList) DeepCopy() *OpenStackPortList {
	if in == nil {
		return nil
	}
	out := new(OpenStackPortList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackPortList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackPortResourceSpec) DeepCopyInto(out *OpenStackPortResourceSpec) {
	*out = *in
	if in.AdminStateUp != nil {
		in, out := &in.AdminStateUp, &out.AdminStateUp
		*out = new(bool)
		**out = **in
	}
	if in.AllowedAddressPairs != nil {
		in, out := &in.AllowedAddressPairs, &out.AllowedAddressPairs
		*out = make([]OpenStackPortAllowedAddressPair, len(*in))
		copy(*out, *in)
	}
	if in.FixedIPs != nil {
		in, out := &in.FixedIPs, &out.FixedIPs
		*out = make([]FixedIP, len(*in))
		copy(*out, *in)
	}
	if in.SecurityGroups != nil {
		in, out := &in.SecurityGroups, &out.SecurityGroups
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.PropagateUplinkStatus != nil {
		in, out := &in.PropagateUplinkStatus, &out.PropagateUplinkStatus
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackPortResourceSpec.
func (in *OpenStackPortResourceSpec) DeepCopy() *OpenStackPortResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackPortResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackPortResourceStatus) DeepCopyInto(out *OpenStackPortResourceStatus) {
	*out = *in
	if in.FixedIPs != nil {
		in, out := &in.FixedIPs, &out.FixedIPs
		*out = make([]OpenStackPortStatusFixedIP, len(*in))
		copy(*out, *in)
	}
	if in.SecurityGroups != nil {
		in, out := &in.SecurityGroups, &out.SecurityGroups
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.AllowedAddressPairs != nil {
		in, out := &in.AllowedAddressPairs, &out.AllowedAddressPairs
		*out = make([]OpenStackPortAllowedAddressPair, len(*in))
		copy(*out, *in)
	}
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.ValueSpecs != nil {
		in, out := &in.ValueSpecs, &out.ValueSpecs
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackPortResourceStatus.
func (in *OpenStackPortResourceStatus) DeepCopy() *OpenStackPortResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackPortResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackPortSpec) DeepCopyInto(out *OpenStackPortSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackPortResourceSpec)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackPortSpec.
func (in *OpenStackPortSpec) DeepCopy() *OpenStackPortSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackPortSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackPortStatus) DeepCopyInto(out *OpenStackPortStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	in.Resource.DeepCopyInto(&out.Resource)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackPortStatus.
func (in *OpenStackPortStatus) DeepCopy() *OpenStackPortStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackPortStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackPortStatusFixedIP) DeepCopyInto(out *OpenStackPortStatusFixedIP) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackPortStatusFixedIP.
func (in *OpenStackPortStatusFixedIP) DeepCopy() *OpenStackPortStatusFixedIP {
	if in == nil {
		return nil
	}
	out := new(OpenStackPortStatusFixedIP)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouter) DeepCopyInto(out *OpenStackRouter) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouter.
func (in *OpenStackRouter) DeepCopy() *OpenStackRouter {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouter)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackRouter) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterExternalFixedIP) DeepCopyInto(out *OpenStackRouterExternalFixedIP) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterExternalFixedIP.
func (in *OpenStackRouterExternalFixedIP) DeepCopy() *OpenStackRouterExternalFixedIP {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterExternalFixedIP)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterInterfaceInfo) DeepCopyInto(out *OpenStackRouterInterfaceInfo) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterInterfaceInfo.
func (in *OpenStackRouterInterfaceInfo) DeepCopy() *OpenStackRouterInterfaceInfo {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterInterfaceInfo)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterList) DeepCopyInto(out *OpenStackRouterList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackRouter, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterList.
func (in *OpenStackRouterList) DeepCopy() *OpenStackRouterList {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackRouterList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterResourceSpec) DeepCopyInto(out *OpenStackRouterResourceSpec) {
	*out = *in
	if in.ExternalGateway != nil {
		in, out := &in.ExternalGateway, &out.ExternalGateway
		*out = new(OpenStackRouterSpecExternalGateway)
		(*in).DeepCopyInto(*out)
	}
	if in.AdminStateUp != nil {
		in, out := &in.AdminStateUp, &out.AdminStateUp
		*out = new(bool)
		**out = **in
	}
	if in.Distributed != nil {
		in, out := &in.Distributed, &out.Distributed
		*out = new(bool)
		**out = **in
	}
	if in.AvailabilityZoneHints != nil {
		in, out := &in.AvailabilityZoneHints, &out.AvailabilityZoneHints
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Ports != nil {
		in, out := &in.Ports, &out.Ports
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterResourceSpec.
func (in *OpenStackRouterResourceSpec) DeepCopy() *OpenStackRouterResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterResourceStatus) DeepCopyInto(out *OpenStackRouterResourceStatus) {
	*out = *in
	in.GatewayInfo.DeepCopyInto(&out.GatewayInfo)
	if in.Ports != nil {
		in, out := &in.Ports, &out.Ports
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Routes != nil {
		in, out := &in.Routes, &out.Routes
		*out = make([]OpenStackRouterRoute, len(*in))
		copy(*out, *in)
	}
	if in.AvailabilityZoneHints != nil {
		in, out := &in.AvailabilityZoneHints, &out.AvailabilityZoneHints
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterResourceStatus.
func (in *OpenStackRouterResourceStatus) DeepCopy() *OpenStackRouterResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterRoute) DeepCopyInto(out *OpenStackRouterRoute) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterRoute.
func (in *OpenStackRouterRoute) DeepCopy() *OpenStackRouterRoute {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterRoute)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterSpec) DeepCopyInto(out *OpenStackRouterSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackRouterResourceSpec)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterSpec.
func (in *OpenStackRouterSpec) DeepCopy() *OpenStackRouterSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterSpecExternalGateway) DeepCopyInto(out *OpenStackRouterSpecExternalGateway) {
	*out = *in
	if in.EnableSNAT != nil {
		in, out := &in.EnableSNAT, &out.EnableSNAT
		*out = new(bool)
		**out = **in
	}
	if in.ExternalFixedIPs != nil {
		in, out := &in.ExternalFixedIPs, &out.ExternalFixedIPs
		*out = make([]OpenStackRouterExternalFixedIP, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterSpecExternalGateway.
func (in *OpenStackRouterSpecExternalGateway) DeepCopy() *OpenStackRouterSpecExternalGateway {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterSpecExternalGateway)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterStatus) DeepCopyInto(out *OpenStackRouterStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	in.Resource.DeepCopyInto(&out.Resource)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterStatus.
func (in *OpenStackRouterStatus) DeepCopy() *OpenStackRouterStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackRouterStatusExternalGatewayInfo) DeepCopyInto(out *OpenStackRouterStatusExternalGatewayInfo) {
	*out = *in
	if in.EnableSNAT != nil {
		in, out := &in.EnableSNAT, &out.EnableSNAT
		*out = new(bool)
		**out = **in
	}
	if in.ExternalFixedIPs != nil {
		in, out := &in.ExternalFixedIPs, &out.ExternalFixedIPs
		*out = make([]OpenStackRouterExternalFixedIP, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackRouterStatusExternalGatewayInfo.
func (in *OpenStackRouterStatusExternalGatewayInfo) DeepCopy() *OpenStackRouterStatusExternalGatewayInfo {
	if in == nil {
		return nil
	}
	out := new(OpenStackRouterStatusExternalGatewayInfo)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroup) DeepCopyInto(out *OpenStackSecurityGroup) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroup.
func (in *OpenStackSecurityGroup) DeepCopy() *OpenStackSecurityGroup {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroup)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackSecurityGroup) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupList) DeepCopyInto(out *OpenStackSecurityGroupList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackSecurityGroup, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupList.
func (in *OpenStackSecurityGroupList) DeepCopy() *OpenStackSecurityGroupList {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackSecurityGroupList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupResourceSpec) DeepCopyInto(out *OpenStackSecurityGroupResourceSpec) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupResourceSpec.
func (in *OpenStackSecurityGroupResourceSpec) DeepCopy() *OpenStackSecurityGroupResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupResourceStatus) DeepCopyInto(out *OpenStackSecurityGroupResourceStatus) {
	*out = *in
	if in.Rules != nil {
		in, out := &in.Rules, &out.Rules
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupResourceStatus.
func (in *OpenStackSecurityGroupResourceStatus) DeepCopy() *OpenStackSecurityGroupResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupRule) DeepCopyInto(out *OpenStackSecurityGroupRule) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupRule.
func (in *OpenStackSecurityGroupRule) DeepCopy() *OpenStackSecurityGroupRule {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupRule)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackSecurityGroupRule) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupRuleList) DeepCopyInto(out *OpenStackSecurityGroupRuleList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackSecurityGroupRule, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupRuleList.
func (in *OpenStackSecurityGroupRuleList) DeepCopy() *OpenStackSecurityGroupRuleList {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupRuleList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackSecurityGroupRuleList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupRuleResourceSpec) DeepCopyInto(out *OpenStackSecurityGroupRuleResourceSpec) {
	*out = *in
	if in.Unmanaged != nil {
		in, out := &in.Unmanaged, &out.Unmanaged
		*out = new(bool)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupRuleResourceSpec.
func (in *OpenStackSecurityGroupRuleResourceSpec) DeepCopy() *OpenStackSecurityGroupRuleResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupRuleResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupRuleResourceStatus) DeepCopyInto(out *OpenStackSecurityGroupRuleResourceStatus) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupRuleResourceStatus.
func (in *OpenStackSecurityGroupRuleResourceStatus) DeepCopy() *OpenStackSecurityGroupRuleResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupRuleResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupRuleSpec) DeepCopyInto(out *OpenStackSecurityGroupRuleSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackSecurityGroupRuleResourceSpec)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupRuleSpec.
func (in *OpenStackSecurityGroupRuleSpec) DeepCopy() *OpenStackSecurityGroupRuleSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupRuleSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupRuleStatus) DeepCopyInto(out *OpenStackSecurityGroupRuleStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	out.Resource = in.Resource
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupRuleStatus.
func (in *OpenStackSecurityGroupRuleStatus) DeepCopy() *OpenStackSecurityGroupRuleStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupRuleStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupSpec) DeepCopyInto(out *OpenStackSecurityGroupSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackSecurityGroupResourceSpec)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupSpec.
func (in *OpenStackSecurityGroupSpec) DeepCopy() *OpenStackSecurityGroupSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSecurityGroupStatus) DeepCopyInto(out *OpenStackSecurityGroupStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	in.Resource.DeepCopyInto(&out.Resource)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSecurityGroupStatus.
func (in *OpenStackSecurityGroupStatus) DeepCopy() *OpenStackSecurityGroupStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackSecurityGroupStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackServer) DeepCopyInto(out *OpenStackServer) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackServer.
func (in *OpenStackServer) DeepCopy() *OpenStackServer {
	if in == nil {
		return nil
	}
	out := new(OpenStackServer)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackServer) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackServerList) DeepCopyInto(out *OpenStackServerList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackServer, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackServerList.
func (in *OpenStackServerList) DeepCopy() *OpenStackServerList {
	if in == nil {
		return nil
	}
	out := new(OpenStackServerList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackServerList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackServerResourceSpec) DeepCopyInto(out *OpenStackServerResourceSpec) {
	*out = *in
	if in.Networks != nil {
		in, out := &in.Networks, &out.Networks
		*out = make([]OpenStackServerSpecNetworks, len(*in))
		copy(*out, *in)
	}
	if in.Metadata != nil {
		in, out := &in.Metadata, &out.Metadata
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.SecurityGroups != nil {
		in, out := &in.SecurityGroups, &out.SecurityGroups
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackServerResourceSpec.
func (in *OpenStackServerResourceSpec) DeepCopy() *OpenStackServerResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackServerResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackServerResourceStatus) DeepCopyInto(out *OpenStackServerResourceStatus) {
	*out = *in
	if in.Links != nil {
		in, out := &in.Links, &out.Links
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.AttachedVolumeIDs != nil {
		in, out := &in.AttachedVolumeIDs, &out.AttachedVolumeIDs
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.ServerGroupIDs != nil {
		in, out := &in.ServerGroupIDs, &out.ServerGroupIDs
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackServerResourceStatus.
func (in *OpenStackServerResourceStatus) DeepCopy() *OpenStackServerResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackServerResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackServerSpec) DeepCopyInto(out *OpenStackServerSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackServerResourceSpec)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackServerSpec.
func (in *OpenStackServerSpec) DeepCopy() *OpenStackServerSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackServerSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackServerSpecNetworks) DeepCopyInto(out *OpenStackServerSpecNetworks) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackServerSpecNetworks.
func (in *OpenStackServerSpecNetworks) DeepCopy() *OpenStackServerSpecNetworks {
	if in == nil {
		return nil
	}
	out := new(OpenStackServerSpecNetworks)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackServerStatus) DeepCopyInto(out *OpenStackServerStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	in.Resource.DeepCopyInto(&out.Resource)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackServerStatus.
func (in *OpenStackServerStatus) DeepCopy() *OpenStackServerStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackServerStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSubnet) DeepCopyInto(out *OpenStackSubnet) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSubnet.
func (in *OpenStackSubnet) DeepCopy() *OpenStackSubnet {
	if in == nil {
		return nil
	}
	out := new(OpenStackSubnet)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackSubnet) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSubnetAllocationPool) DeepCopyInto(out *OpenStackSubnetAllocationPool) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSubnetAllocationPool.
func (in *OpenStackSubnetAllocationPool) DeepCopy() *OpenStackSubnetAllocationPool {
	if in == nil {
		return nil
	}
	out := new(OpenStackSubnetAllocationPool)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSubnetHostRoute) DeepCopyInto(out *OpenStackSubnetHostRoute) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSubnetHostRoute.
func (in *OpenStackSubnetHostRoute) DeepCopy() *OpenStackSubnetHostRoute {
	if in == nil {
		return nil
	}
	out := new(OpenStackSubnetHostRoute)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSubnetList) DeepCopyInto(out *OpenStackSubnetList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]OpenStackSubnet, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSubnetList.
func (in *OpenStackSubnetList) DeepCopy() *OpenStackSubnetList {
	if in == nil {
		return nil
	}
	out := new(OpenStackSubnetList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *OpenStackSubnetList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSubnetResourceSpec) DeepCopyInto(out *OpenStackSubnetResourceSpec) {
	*out = *in
	if in.AllocationPools != nil {
		in, out := &in.AllocationPools, &out.AllocationPools
		*out = make([]OpenStackSubnetAllocationPool, len(*in))
		copy(*out, *in)
	}
	if in.GatewayIP != nil {
		in, out := &in.GatewayIP, &out.GatewayIP
		*out = new(string)
		**out = **in
	}
	if in.EnableDHCP != nil {
		in, out := &in.EnableDHCP, &out.EnableDHCP
		*out = new(bool)
		**out = **in
	}
	if in.DNSNameservers != nil {
		in, out := &in.DNSNameservers, &out.DNSNameservers
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.ServiceTypes != nil {
		in, out := &in.ServiceTypes, &out.ServiceTypes
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.HostRoutes != nil {
		in, out := &in.HostRoutes, &out.HostRoutes
		*out = make([]OpenStackSubnetHostRoute, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSubnetResourceSpec.
func (in *OpenStackSubnetResourceSpec) DeepCopy() *OpenStackSubnetResourceSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackSubnetResourceSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSubnetResourceStatus) DeepCopyInto(out *OpenStackSubnetResourceStatus) {
	*out = *in
	if in.DNSNameservers != nil {
		in, out := &in.DNSNameservers, &out.DNSNameservers
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.ServiceTypes != nil {
		in, out := &in.ServiceTypes, &out.ServiceTypes
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
	if in.AllocationPools != nil {
		in, out := &in.AllocationPools, &out.AllocationPools
		*out = make([]OpenStackSubnetAllocationPool, len(*in))
		copy(*out, *in)
	}
	if in.HostRoutes != nil {
		in, out := &in.HostRoutes, &out.HostRoutes
		*out = make([]OpenStackSubnetHostRoute, len(*in))
		copy(*out, *in)
	}
	if in.Tags != nil {
		in, out := &in.Tags, &out.Tags
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSubnetResourceStatus.
func (in *OpenStackSubnetResourceStatus) DeepCopy() *OpenStackSubnetResourceStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackSubnetResourceStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSubnetSpec) DeepCopyInto(out *OpenStackSubnetSpec) {
	*out = *in
	out.CommonSpec = in.CommonSpec
	if in.Resource != nil {
		in, out := &in.Resource, &out.Resource
		*out = new(OpenStackSubnetResourceSpec)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSubnetSpec.
func (in *OpenStackSubnetSpec) DeepCopy() *OpenStackSubnetSpec {
	if in == nil {
		return nil
	}
	out := new(OpenStackSubnetSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *OpenStackSubnetStatus) DeepCopyInto(out *OpenStackSubnetStatus) {
	*out = *in
	in.CommonStatus.DeepCopyInto(&out.CommonStatus)
	in.Resource.DeepCopyInto(&out.Resource)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new OpenStackSubnetStatus.
func (in *OpenStackSubnetStatus) DeepCopy() *OpenStackSubnetStatus {
	if in == nil {
		return nil
	}
	out := new(OpenStackSubnetStatus)
	in.DeepCopyInto(out)
	return out
}
